import peasy.*;
PeasyCam cam;
import controlP5.*;
ControlP5 cp5;
import processing.opengl.*;
// 10 tables for count number of every month
Table[] tables= new Table[10];
Table table0, table1, table2, table3;
float[][] dataMatrix0;
float[][] dataMatrix1;
float[][] dataMatrix2;
float[][] dataMatrix3;
// tables rows
int numRows0, numRows1, numRows2, numRows3;
// min_max value of table
//float maxValue, minValue;

// 10 tables for every record
ArrayList<Record> records0 = new ArrayList<Record>();
ArrayList<Record> records1 = new ArrayList<Record>();
ArrayList<Record> records2 = new ArrayList<Record>();
ArrayList<Record> records3 = new ArrayList<Record>();
ArrayList<Record> records4 = new ArrayList<Record>();
ArrayList<Record> records5 = new ArrayList<Record>();
ArrayList<Record> records6 = new ArrayList<Record>();
ArrayList<Record> records7 = new ArrayList<Record>();
ArrayList<Record> records8 = new ArrayList<Record>();
ArrayList<Record> records9 = new ArrayList<Record>();

// arraylist rows
int[] rowNums= new int[10];

// 
float px, py;
float vx, vy, vz;
float angle;
float radius;
float startYear=2005.0;
float startMonth=0.0;

color c;

//float frequency = 1;
boolean labelApplied=false;
boolean shapeApplied=false;
boolean showDataOne=false;
boolean showDataTwo=false;
boolean showDataThree=false;
boolean showDataFour=false;
boolean showLineOne=false;
boolean showLineTwo=false;
boolean showLineThree=false;
boolean showLineFour=false;
boolean rectOne=false;
boolean rectTwo=false;
boolean rectThree=false;
boolean rectFour=false;
boolean textOne=false;
boolean textTwo=false;
boolean textThree=false;
boolean textFour=false;
boolean showPoint=true;
boolean showBox;



void setup() {
  size(1200, 800, P3D);
  cam = new PeasyCam(this, 200);
  cam.setMinimumDistance(200);
  cam.setMaximumDistance(5000);
  background(20);
  //  lights();
  tables[0]=loadTable("the da vinci code.csv", "header");
  table0=loadTable("countDVC.csv", "header");
  tables[1]=loadTable("time travelers wife.csv", "header");
  table1=loadTable("countTTW.csv", "header");
  tables[2]=loadTable("hunger games.csv", "header");
  table2=loadTable("countHG.csv", "header");
  tables[3]=loadTable("fault in our stars.csv", "header");
  table3=loadTable("countFIOS.csv", "header");

  rowNums[0]=tables[0].getRowCount();
  rowNums[1]=tables[1].getRowCount();
  rowNums[2]=tables[2].getRowCount();
  rowNums[3]=tables[3].getRowCount();

  numRows0 = table0.getRowCount();
  numRows1 = table1.getRowCount();
  numRows2 = table2.getRowCount();
  numRows3 = table3.getRowCount();

  /*dataMatrix3 = new float[numRows3][2];
   for (int i=0; i<numRows3; i++) {
   for (int j=0; j<2; j++) {
   dataMatrix3[i][j] = table3.getFloat(i, j+2);
   }
   }
   maxValue = max2D(dataMatrix3);
   minValue = min2D(dataMatrix3);
   
   println("Max Value is " + maxValue);
   println("Min Value is " + minValue);*/

  // put 3 parameters into records
  for (int i=0; i<rowNums[0]; i++) {
    String date = tables[0].getString(i, 0);
    String time = tables[0].getString(i, 1);
    int duration= tables[0].getInt(i, 2);
    records0.add(new Record(time, date, duration));
  }
  for (int i=0; i<records0.size(); i++ ) {
    float year = yearParser(records0.get(i).date);
    float month = monthParser(records0.get(i).date);
    for (int j=0; j < numRows0; j++) {
      if (year == table0.getFloat(j, 1)) {
        if (month == table0.getFloat(j, 2)) {
          records0.get(i).counts = table0.getInt(j, 3);
        }
      }
    }
  }


  for (int i=0; i<rowNums[1]; i++) {
    String date = tables[1].getString(i, 0);
    String time = tables[1].getString(i, 1);
    int duration= tables[1].getInt(i, 2);
    records1.add(new Record(time, date, duration));
  }
  for (int i=0; i<records1.size(); i++ ) {
    float year = yearParser(records1.get(i).date);
    float month = monthParser(records1.get(i).date);
    for (int j=0; j < numRows1; j++) {
      if (year == table1.getFloat(j, 1)) {
        if (month == table1.getFloat(j, 2)) {
          records1.get(i).counts = table1.getInt(j, 3);
        }
      }
    }
  }

  for (int i=0; i<rowNums[2]; i++) {
    String date = tables[2].getString(i, 0);
    String time = tables[2].getString(i, 1);
    int duration= tables[2].getInt(i, 2);
    records2.add(new Record(time, date, duration));
  }
  for (int i=0; i<records2.size(); i++ ) {
    float year = yearParser(records2.get(i).date);
    float month = monthParser(records2.get(i).date);
    for (int j=0; j < numRows2; j++) {
      if (year == table2.getFloat(j, 1)) {
        if (month == table2.getFloat(j, 2)) {
          records2.get(i).counts = table2.getInt(j, 3);
        }
      }
    }
  }

  for (int i=0; i<rowNums[3]; i++) {
    String date = tables[3].getString(i, 0);
    String time = tables[3].getString(i, 1);
    int duration= tables[3].getInt(i, 2);
    records3.add(new Record(time, date, duration));
  }
  for (int i=0; i<records3.size(); i++ ) {
    float year = yearParser(records3.get(i).date);
    float month = monthParser(records3.get(i).date);
    for (int j=0; j < numRows3; j++) {
      if (year == table3.getFloat(j, 1)) {
        if (month == table3.getFloat(j, 2)) {
          records3.get(i).counts = table3.getInt(j, 3);
        }
      }
    }
  }
}

void draw() {
  //translate(width/2, height/2, 0);
  background(20);

  //pushMatrix();
  //translate(200, 200, 200);
  pushMatrix();
  rotateZ(PI*3/4);
  rotateY(PI);
  rotateX(PI);
  rotateX(-PI/4);
  rotateX(-PI/4);
  textAlign(LEFT, CENTER);
  textSize(20);
  fill(#ffffff);
  scale(0.5);
  text("2015        2014       2013       2012       2011       2010       2009       2008       2007        2006 ", 
    -1000, 10, 0);
  popMatrix();
  //Draw TiTle
  pushMatrix();
  textAlign(LEFT, CENTER);
  textSize(260);
  scale(0.1);
  fill(#e9f0f4);
  text("FILM                       INFLUENCE", 200, 250, 0);
  fill(#81e298);
  text("ADAPTATION", 870, 250, 0);
  popMatrix();
  pushMatrix();
  textSize(140);
  fill(#e9f0f4);
  scale(0.1);
  text("From Seattle Public Library", 200, 0, 0);
  text("The Trend of Checkout Numbers of Books During Corresponding Adaptation Film Released Time", 
    200, 530, 0 );
  popMatrix();


  cam.beginHUD();
  if (labelApplied==true)labelAppeared();
  if (rectOne)introduction1();
  if (rectTwo)introduction2();
  if (rectThree)introduction3();
  if (rectFour)introduction4();
  cam.endHUD();

  stroke(100, 125);
  strokeWeight(1);
  noFill();
  for (int i=1; i<11; i++) {
    radius=48*2;    
    ellipse(0, 0, radius*i, radius*i);
  }

  line(0, 0, 100, 0, 0, -100);
  rotateX(-PI/2);

  //if (shapeApplied==true)shapeAppeared();   
  if (showDataOne==true)shapeAppeared0();   
  if (showDataTwo==true)shapeAppeared1();   
  if (showDataThree==true)shapeAppeared2();  
  if (showDataFour==true)shapeAppeared3();

  if (showLineOne==true)lineAppeared0();   
  if (showLineTwo==true)lineAppeared1();   
  if (showLineThree==true)lineAppeared2();  
  if (showLineFour==true)lineAppeared3();

  if (textOne==true)monthIntro0();   
  if (textTwo==true)monthIntro1();   
  if (textThree==true)monthIntro2();  
  if (textFour==true)monthIntro3();
}